# pion::PionCounter Class Reference

`#include <PionCounter.hpp>`

List of all members.

## Detailed Description

PionCounter: thread-safe 64-bit integer counter

Definition at line 24 of file PionCounter.hpp.

## Public Member Functions

| PionCounter (unsigned long n=0)
| default constructor initializes counter
virtual | ~PionCounter ()
| virtual destructor: class may be extended
| PionCounter (const PionCounter &c)
| copy constructor
const PionCounter & | operator= (const PionCounter &c)
| assignment operator
const PionCounter & | operator++ (void)
| prefix increment
const PionCounter & | operator-- (void)
| prefix decrement
template<typename IntegerType>
const PionCounter & | operator+= (const IntegerType &n)
| adds integer value to the counter
template<typename IntegerType>
const PionCounter & | operator-= (const IntegerType &n)
| subtracts integer value from the counter
template<typename IntegerType>
const PionCounter & | operator= (const IntegerType &n)
| assigns integer value to the counter
template<typename IntegerType>
bool | operator== (const IntegerType &n) const
| compares an integer value to the counter
template<typename IntegerType>
bool | operator> (const IntegerType &n) const
| compares an integer value to the counter
template<typename IntegerType>
bool | operator< (const IntegerType &n) const
| compares an integer value to the counter
template<typename IntegerType>
bool | operator>= (const IntegerType &n) const
| compares an integer value to the counter
template<typename IntegerType>
bool | operator<= (const IntegerType &n) const
| compares an integer value to the counter
void | reset (void)
| resets the counter to zero
boost::uint64_t | getValue (void) const
| returns the value of the counter

## Protected Member Functions

void | increment (void)
| increments the value of the counter
void | decrement (void)
| decrement the value of the counter
template<typename IntegerType>
void | add (const IntegerType &n)
| adds a value to the counter
template<typename IntegerType>
void | subtract (const IntegerType &n)
| subtracts a value from the counter
template<typename IntegerType>
void | assign (const IntegerType &n)
| assigns a new value to the counter

The documentation for this class was generated from the following file:

- common/include/pion/PionCounter.hpp